;
; IDL Event Callback Procedures
; MSP_MOT_GUI_eventcb
;
; Generated on:	01/03/2011 10:22.05
;
;	v1.0.0	20110103	DPC
;
;------------------------------------------
pro MSP_MOT_GUI_PostCreation, wWidget, _EXTRA=_VWBExtra_
	;
	;	get computer name
	;
	host = GETENV('computername')
	if(strlen(host) eq 0) then host = GETENV('HOSTNAME')
	;
	version_short_string = 'v1.0.0 20110103 on '+STRTRIM(host,2)
	version_string = 'MSP_MOT (Mimir Software Package - Mosaic and Overlay Tool) '+version_short_string
	;
	;	set up and clear summary structure
	;
	summary_struct = {	version_string: version_string, 	$	for window title
						version_short_string: version_short_string,	$	for inclusion on data files
						analysis_dir:			'',			$	root of director structure
						last_dir:				'',			$   last raw data directory accessed
						lu_log:					0L,			$	lu of log file
						log_path:				''			$ 	pathname to the log file
						;
					  }
	;
	image_struct = {	n_images:				0L, 		$	number of images
						image_filenames: 	strarr(1000),	$ 	file name designations
						image_pathnames:	strarr(1000), 	$   pathnames of images
						nx:					lonarr(1000), 	$	columns in each image
						ny:					lonarr(1000), 	$	rows in each image
						theta:				dblarr(1000),	$	rotation angle, in deg, clockwise from disk array to sky
						scale:				dblarr(1000),	$	plate scale, in deg per pixel
						xl_off:				lonarr(1000),	$	x offset of lower left pixel center to lower left output image pixel
						yl_off:				lonarr(1000),	$	same for y
						background:			dblarr(1000),	$	background level in each image
						s_background:		dblarr(1000),	$	uncertainty in background level
						;
						gal_angle:					0.0 , 	$	angle to rotate from Equ to Gal (E from N) in deg (CCW)
						;
						h_lower:			         0.0,	$   histogram lower mark level
						h_upper:					 0.0, 	$
						;
						d_xl:						 0L,	$	display lower left corner in mosaic pixel number
						d_yl:						 0L,	$
						d_xu:						 0L, 	$
						d_yu:						 0L, 	$
						;
						crpix1:				dblarr(1000),	$
						crpix2:				dblarr(1000),	$
						crval1:				dblarr(1000),	$
						crval2:				dblarr(1000),	$
						crdelt1:			dblarr(1000),	$
						crdelt2:			dblarr(1000),	$
						cd1_1:				dblarr(1000),	$
						cd1_2:				dblarr(1000),	$
						cd2_1:				dblarr(1000),	$
						cd2_2:				dblarr(1000),	$
						;
						o_nx:							0L, $
						o_ny:							0L, $
						o_crpix1:						0L, $
						o_crpix2:						0L, $
						o_crval1:					0.0d0 , $
						o_crval2:					0.0d0 , $
						o_cd1_1:					0.0d0 , $
						o_cd1_2:					0.0d0 , $
						o_cd2_1:					0.0d0 , $
						o_cd2_2:					0.0d0 , $
						o_image:	PTR_NEW(/allocate_heap),$	space for the output image
						o_region:	PTR_NEW(/allocate_heap)	$	space for regions list
						;
					  }
	history_struct = 	{	history_buffer:			strarr(10,500),  $	; one buffer per main tab
							n_history:				lonarr(10),		$	; number of entries on each buffer
							max_lines:					500L		$   ; maximum number of lines to save
						}
	crop_struct = 	   { 	crop_flag:			0L, 		$	0 = no cropping; 1 = cropping
							crop_basis:			0L,			$	0 = image center; 1 = lower left pixel in image
							xl:					0L,  		$   lower left column limit
							yl:					0L,			$   lower left row limit
							xu:					0L,  		$	upper right column limit
							yu:					0L  		$	upper right row limit
						}
	;
	widget_ID_struct = {	Base_text_box_wid:	 				0L,	$
							Base_exit_button_wid: 				0L,	$
							Base_tab_wid: 						0L,	$
							;
							S0_last_display:				'none', $
							S0_select_images_button_wid:		0L, $
							S0_images_textbox_wid:				0L, $
							S0_crop_checkbox_wid:				0L, $
							S0_modify_crop_button_wid: 			0L, $
							S0_crop_textbox_wid: 				0L, $
							S0_create_mosaic_button_wid:		0L, $
							S0_match_backgrounds_checkbox_wid: 	0L, $
								S0_match_backgrounds_flag:		1L, $
							S0_write_FITS_button_wid: 			0L, $
							S0_combine_CATs_checkbox_wid: 		0L, $
								S0_combine_CATs_flag:			0L, $
							S0_combine_regions_checkbox_wid:	0L, $
								S0_combine_regions_flag:		1L, $
							S0_rotate_to_galactic_checkbox_wid:	0L, $
								S0_rotate_to_galactic_flag:		1L, $
							S0_draw_window_wid: 				0L, $
								win_no_0:						0L, $	draw window window number
							S0_offset_slider_wid: 				0L, $
								S0_offset_slider_value:		  30L, $
							S0_range_slider_wid: 				0L, $
								S0_range_slider_value:	      100L, $
							S0_write_TIFF_button_wid: 			0L, $
							S0_write_region_file_button_wid:	0L, $
							S0_write_cats_button_wid:			0L, $
							S0_display_regions_checkbox_wid:	0L, $
								S0_display_regions_flag:		1L, $
							S0_display_histogram_button_wid:	0L, $
							S0_scale_method_droplist_wid:		0L, $
								S0_scale_method:		  'Linear', $
							S0_lut_droplist_wid:				0L, $
							    S0_lut:					  'Rainbow',$
							S0_display_image_button_wid: 		0L  $
							;
						}
	;
	;	step-specific structures
	;
	PTR_summary = PTR_NEW(summary_struct,/NO_COPY)
	PTR_image = PTR_NEW(image_struct,/NO_COPY)
	PTR_history = PTR_NEW(history_struct, /NO_COPY)
	PTR_crop = PTR_NEW(crop_struct, /NO_COPY)
	PTR_wid_id = PTR_NEW(widget_ID_struct,/NO_COPY)
    ;
    ;	load the pointer(s) into the pointer structure
    ;
    PTR_struct = {PTR_summary: PTR_summary, PTR_image: PTR_image, PTR_history: PTR_history, $
    				PTR_crop: PTR_crop, PTR_wid_id: PTR_wid_id }
    ;
    WIDGET_CONTROL, wWidget, SET_UVALUE=PTR_struct
end

;-----------------------------------------------------------------
pro Base_Exit_Button_Press, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct	;	close log file
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid_id
	i_ptr = PTR_struct.PTR_image
	c_ptr = PTR_struct.PTR_crop
	h_ptr = PTR_struct.PTR_history
	;
	if( (*s_ptr).lu_log ne 0) then FREE_LUN, (*s_ptr).lu_log
	;
	;free the pointers
	;
	;	and then the full structure pointers
	;
	PTR_FREE, w_ptr
	PTR_FREE, (*i_ptr).o_image
	PTR_FREE, (*i_ptr).o_region
	PTR_FREE, i_ptr
	PTR_FREE, c_ptr
	PTR_FREE, h_ptr
	PTR_FREE, s_ptr
	;
	WIDGET_CONTROL, Event.top, /DESTROY
end
;
;-----------------------------------------------------------------
pro MSP_MOT_GUI_Realize, wWidget
	WIDGET_CONTROL, wWidget, GET_UVALUE=PTR_struct
	;
	;	load all the widget IDs
	;
	;	need to pass an event structure:
	;
	event = {top: wWidget}
	get_wids, event
	;
	;	reread the pointer structure to get updated wids
	;
	WIDGET_CONTROL, wWidget, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	;
	TLB_Title = (*s_ptr).version_string
    tlb_wid = WIDGET_INFO( Event.top, FIND_BY_UNAME='MSP_MOT_Base')
    WIDGET_CONTROL, tlb_wid, TLB_SET_TITLE=TLB_Title
	;
	w_ptr = PTR_struct.PTR_wid_id
	;
	;	initialize gui-s
	;
	S0_Init, event
	;
	print_text, event, "Mimir Software Package: Mosaic and Overlay Tool - Initialized!"
	;
end
;
;-----------------
pro S0_Handler, Event
	;
	;	figure out which button was pushed and launch the right routine
	;
	buttons = [	"S0_Select_Images_Button",$
				"S0_Crop_Checkbox",$
				"S0_Modify_Crop_Button",$
				"S0_Create_Mosaic_Button",$
				"S0_Match_Backgrounds_Checkbox",$
				"S0_Write_FITS_Button",$
				"S0_Combine_CATs_Checkbox",$
				"S0_Combine_Regions_Checkbox",$
				"S0_Rotate_to_Galactic_Checkbox",$
				"S0_Offset_Slider",$
				"S0_Range_Slider",$
				"S0_Write_TIFF_Button",$
				"S0_Display_Regions_Checkbox",$
				"S0_Display_Image_Button", $
				"S0_Display_Histogram_Button",$
				"S0_Write_Region_File_Button",$
				"S0_Write_CATs_Button",$
				"S0_LUT_Droplist",$
				"S0_Scale_Method_Droplist" $
			   ]
	wid_button = Event.id
	n_buttons = N_ELEMENTS(buttons)
	button_wids = lonarr(n_buttons)
	for iw = 0, n_buttons-1 do button_wids[iw] = WIDGET_INFO(Event.top, FIND_BY_UNAME=buttons[iw])
	;
	ind = WHERE(button_wids[*] eq wid_button, count)
	if(count ne 0) then begin
		case wid_button of
			button_wids[0]: S0_Select_Images, Event
			button_wids[1]: S0_Toggle_Crop_Flag, Event
			button_wids[2]: S0_Modify_Crop, Event
			button_wids[3]: S0_Create_Mosaic, Event
			button_wids[4]: S0_Toggle_Match_Backgrounds, Event
			button_wids[5]: S0_Write_FITS, event
			button_wids[6]: S0_Toggle_Combine_CATs, Event
			button_wids[7]: S0_Toggle_Combine_Regions, Event
			button_wids[8]: S0_Toggle_Rotate_to_Galactic, Event
			button_wids[9]: S0_Change_LUT, 0, Event
			button_wids[10]: S0_Change_LUT, 1, Event
			button_wids[11]: S0_Write_TIFF, Event
			button_wids[12]: S0_Toggle_Display_Regions, Event
			button_wids[13]: S0_Display_Image, Event
			button_wids[14]: S0_Display_Histogram, Event
			button_wids[15]: S0_Write_Region_File, Event
			button_wids[16]: S0_Write_CATs, Event
			button_wids[17]: S0_Set_LUT, Event
			button_wids[18]: S0_Set_Scale_Method, Event
			else: print_text, Event, "Error - button push not recognized"
	    endcase
	endif else print_text, Event, "No button pushed."
end
;
; Empty stub procedure used for autoloading.
;
pro MSP_MOT_GUI_eventcb
end
