;
;	S0 Handler Routines
;
pro S0_Init, Event
	;
	;	initialize stuff when starting project
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	c_ptr = PTR_struct.PTR_crop
	;
;	h_wid = (*w_ptr).S9_history_textbox_wid
	;
	;	initialize options buttons
	;
	(*c_ptr).crop_flag = 1 - (*c_ptr).crop_flag
	S0_Toggle_Crop_Flag, Event
	;
	(*w_ptr).S0_match_backgrounds_flag = 1 - (*w_ptr).S0_match_backgrounds_flag
	S0_Toggle_Match_Backgrounds, Event
	;
	(*w_ptr).S0_combine_CATs_flag = 1 - (*w_ptr).S0_combine_CATs_flag
	S0_Toggle_Combine_CATs, Event
	;
	(*w_ptr).S0_rotate_to_galactic_flag = 1 - (*w_ptr).S0_rotate_to_galactic_flag
	S0_Toggle_Rotate_to_Galactic, Event
	;
	(*w_ptr).S0_display_regions_flag = 1 - (*w_ptr).S0_display_regions_flag
	S0_Toggle_Display_Regions, Event
	;
	(*w_ptr).S0_combine_regions_flag = 1 - (*w_ptr).S0_combine_regions_flag
	S0_Toggle_Combine_Regions, Event
	;
	;	clear the image text buffer
	;
	WIDGET_CONTROL, (*w_ptr).S0_images_textbox_wid,SET_VALUE=''
	;
	;	clear the drawing window
	;
	WIDGET_CONTROL, (*w_ptr).S0_draw_window_wid, GET_VALUE=win_no_0
	(*w_ptr).win_no_0 = win_no_0
	wset, (*w_ptr).win_no_0
	erase
	;
;	geo = WIDGET_INFO( (*w_ptr).S0_draw_window_wid, /GEOMETRY )
	;
	;	and set maxima for the sliders
	;
	WIDGET_CONTROL, (*w_ptr).S0_offset_slider_wid, SET_SLIDER_MAX = 255
	WIDGET_CONTROL, (*w_ptr).S0_range_slider_wid, SET_SLIDER_MAX = 255
	;
	;	and set them
	;
	WIDGET_CONTROL, (*w_ptr).S0_offset_slider_wid, SET_VALUE = (*w_ptr).S0_offset_slider_value
	WIDGET_CONTROL, (*w_ptr).S0_range_slider_wid, SET_VALUE = (*w_ptr).S0_range_slider_value
	;
	;	turn off all but first button
	;
	WIDGET_CONTROL, (*w_ptr).S0_crop_checkbox_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_images_textbox_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_crop_textbox_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_modify_crop_button_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_create_mosaic_button_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_match_backgrounds_checkbox_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_write_FITS_button_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_combine_CATs_checkbox_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_combine_regions_checkbox_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_rotate_to_galactic_checkbox_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_draw_window_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_offset_slider_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_range_slider_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_write_TIFF_button_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_display_regions_checkbox_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_display_image_button_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_display_histogram_button_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_scale_method_droplist_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_lut_droplist_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_write_region_file_button_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_write_cats_button_wid, SENSITIVE=0
	;
end
;
;-----------------------------------------------
pro S0_Set_Scale_Method, Event
	;
	;	capture the scaling method from the droplist
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	WIDGET_CONTROL, (*w_ptr).S0_scale_method_droplist_wid, GET_VALUE=new_method
	(*w_ptr).S0_scale_method = new_method[Event.index]
	;
	case (*w_ptr).S0_scale_method of
		'Linear': print_text, Event, "Changing scaling mode to LINEAR"
		'Log': print_text, Event, "Changing scaling mode to LOG"
		'Sqrt': print_text, Event, "Changing scaling mode to SQRT"
	endcase
	;
	;	and reissue the last display command (either histo or plot)
	;
	case (*w_ptr).S0_last_display of
		'histo': S0_Display_Histogram, Event
		'image': S0_Display_Image, Event
		else: print_text, Event, 'No display requested'
	endcase
	;
end
;-----------------------------------------------
pro S0_Set_LUT, Event
	;
	;	sets the lut from the droplist
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	WIDGET_CONTROL, (*w_ptr).S0_lut_droplist_wid, GET_VALUE=new_method
	(*w_ptr).S0_lut = new_method[Event.index]
	;
	case (*w_ptr).S0_lut of
		'Rainbow': print_text, Event, "Changing look-up table to Rainbow"
		'Gray Scale': print_text, Event, "Changing look-up table to GRAY SCALE"
		'Red BB': print_text, Event, "Changing look-up table to RED BB"
		'Inverse Gray': print_text, Event, "Changing look-up table to INVERSE GRAY"
	endcase
	;
	;	and reissue the last display command (either histo or plot)
	;
	case (*w_ptr).S0_last_display of
;		'histo': S0_Display_Histogram, Event
		'image': S0_Display_Image, Event
		else: print_text, Event, 'No display requested'
	endcase
end
;-----------------------------------------------
pro S0_Toggle_Crop_Flag, Event
	;
	;	toggle cropping
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	c_ptr = PTR_struct.PTR_crop
	;
	(*c_ptr).crop_flag = 1 - (*c_ptr).crop_flag
	;
	WIDGET_CONTROL, (*w_ptr).S0_crop_checkbox_wid, SET_BUTTON=(*c_ptr).crop_flag
	;
	case (*c_ptr).crop_flag of
		0: print_text, Event, "Changing mode to NOT use image cropping"
		1: print_text, Event, "Changing mode to USE image_cropping"
	endcase
	;
end
;-----------------------------------------------
pro S0_Modify_Crop, Event
	;
	;	change cropping
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	c_ptr = PTR_struct.PTR_crop
	;
;	(*c_ptr).crop_flag = 1 - (*c_ptr).crop_flag
;	;
;	WIDGET_CONTROL, (*w_ptr).S0_crop_checkbox_wid, SET_BUTTON=(*c_ptr).crop_flag
;	;
;	case (*c_ptr).crop_flag of
;		0: print_text, Event, "Changing mode to NOT use image cropping"
;		1: print_text, Event, "Changing mode to USE image_cropping"
;	endcase
	;
end
;-----------------------------------------------
pro S0_Toggle_Match_Backgrounds, Event
	;
	;	toggle background matching
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	(*w_ptr).S0_match_backgrounds_flag = 1 - (*w_ptr).S0_match_backgrounds_flag
	;
	WIDGET_CONTROL, (*w_ptr).S0_match_backgrounds_checkbox_wid, SET_BUTTON=(*w_ptr).S0_match_backgrounds_flag
	;
	case (*w_ptr).S0_match_backgrounds_flag of
		0: print_text, Event, "Changing mode to NOT match image background levels"
		1: print_text, Event, "Changing mode to match image background levels"
	endcase
	;
end
;-----------------------------------------------
pro S0_Toggle_Combine_CATs, Event
	;
	;	toggle POLCAT, PHOTCAT combining
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	(*w_ptr).S0_combine_CATs_flag = 1 - (*w_ptr).S0_combine_CATs_flag
	;
	WIDGET_CONTROL, (*w_ptr).S0_combine_CATs_checkbox_wid, SET_BUTTON=(*w_ptr).S0_combine_CATs_flag
	;
	case (*w_ptr).S0_combine_CATs_flag of
		0: print_text, Event, "Changing mode to NOT combine PHOTCATs and POLCATs"
		1: print_text, Event, "Changing mode to combine PHOTCATs and POLCATs"
	endcase
	;
end
;-----------------------------------------------
pro S0_Toggle_Combine_Regions, Event
	;
	;	toggle POLCAT, PHOTCAT combining
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	(*w_ptr).S0_combine_regions_flag = 1 - (*w_ptr).S0_combine_regions_flag
	;
	WIDGET_CONTROL, (*w_ptr).S0_combine_regions_checkbox_wid, SET_BUTTON=(*w_ptr).S0_combine_regions_flag
	;
	case (*w_ptr).S0_combine_regions_flag of
		0: print_text, Event, "Changing mode to NOT combine DS9 overlay regions files"
		1: print_text, Event, "Changing mode to combine DS9 overlay regions files"
	endcase
	;
end
;-----------------------------------------------
pro S0_Toggle_Rotate_to_Galactic, Event
	;
	;	toggle rotating image to galactic coordinates
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	(*w_ptr).S0_rotate_to_galactic_flag = 1 - (*w_ptr).S0_rotate_to_galactic_flag
	;
	WIDGET_CONTROL, (*w_ptr).S0_rotate_to_galactic_checkbox_wid, SET_BUTTON=(*w_ptr).S0_rotate_to_galactic_flag
	;
	case (*w_ptr).S0_rotate_to_galactic_flag of
		0: print_text, Event, "Changing mode to NOT rotate image to galactic coordinates"

		1: print_text, Event, "Changing mode to rotate image to galactic coordinates"
	endcase
	;
end
;-----------------------------------------------
pro S0_Toggle_Display_Regions, Event
	;
	;	toggle display of regions overlay
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	i_ptr = PTR_struct.PTR_image
	;
	(*w_ptr).S0_display_regions_flag = 1 - (*w_ptr).S0_display_regions_flag
	;
	WIDGET_CONTROL, (*w_ptr).S0_display_regions_checkbox_wid, SET_BUTTON=(*w_ptr).S0_display_regions_flag
	;
	case (*w_ptr).S0_display_regions_flag of
		0: begin
				print_text, Event, "Changing mode to NOT write regions to TIFF"
				;
				;	if was image display, redisplay
				;
				if( (*w_ptr).S0_last_display eq 'image') then S0_Display_Image, Event
			end
		1: begin
				print_text, Event, "Changing mode to write regions to TIFF"
				;
				;	if region files processed, display on image
				;
				if( N_ELEMENTS( (*(*i_ptr).o_region) ) gt 0) then begin
					;
					;	recover display limits and test for vector corners fully within limits
					;
				endif
			end
	endcase
	;
end
;-----------------------------------------------
pro S0_Select_Images, Event
	;
	;	paint file chooser and get image list
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	i_ptr = PTR_struct.PTR_image
	;
	;	clear all buffers, plots
	;
	S0_Init, Event
	;
	files_in = dialog_pickfile(Title="Select FITS Images to Mosaic",/MULTIPLE_FILES)
	n_files = N_ELEMENTS(files_in)
	if(n_files eq 1) then begin
		if(files_in eq '') then begin
			print_text, Event, 'ERROR - no files selected. Try again'
			goto, SSI_end
		endif
	endif
	;
	;	sort the name list
	;
	ind_sort = SORT( files_in )
	files_in = files_in[ind_sort]
	(*i_ptr).n_images = n_files
	(*i_ptr).image_pathnames[0:n_files-1] = files_in[*]
	(*i_ptr).image_filenames[0:n_files-1] = FILE_BASENAME(files_in[*])
	;
	print_text, Event, 'Read in '+STRING(n_files,format='(A)')+' images'
	;
	print_text, Event, 'Starting Evaluations of Sizes, Backgrounds'
	;
	;	prepare to evaluate each image
	;
	image_text = strarr(n_files)
	;
	WIDGET_CONTROL, (*w_ptr).S0_images_textbox_wid,SENSITIVE=1
	;
	for i_image = 0, n_files-1 do begin
		this_file = FILE_BASENAME(files_in[i_image])
		data_array = PTR_NEW(/ALLOCATE_HEAP)
		header_array = PTR_NEW(/ALLOCATE_HEAP)
		clean_array = PTR_NEW(/ALLOCATE_HEAP)
		;
		(*data_array) = readfits(files_in[i_image],(*header_array),/silent)
		;
		NX = SXPAR( (*header_array), 'NAXIS1', COUNT=count)
		if(count ne 1) then begin
			print_text, Event, 'ERROR - image '+this_file+' had bad NAXIS1 '
		endif
		NY = SXPAR( (*header_array), 'NAXIS2', COUNT=count)
		if(count ne 1) then begin
			print_text, Event, 'ERROR - image '+this_file+' had bad NAXIS2 '
		endif
		;
		;	determine background
		;
		(*clean_array) = model_background( (*data_array), SKY=sky, /LOW_ORDER, SIGMA = sigma )
		;
		;	save background, nx, ny info and print to line in textbox
		;
		(*i_ptr).nx[i_image] = nx
		(*i_ptr).ny[i_image] = ny
		(*i_ptr).crpix1[i_image] = SXPAR( (*header_array), 'CRPIX1')
		(*i_ptr).crpix2[i_image] = SXPAR( (*header_array), 'CRPIX2')
		(*i_ptr).crval1[i_image] = SXPAR( (*header_array), 'CRVAL1')
		(*i_ptr).crval2[i_image] = SXPAR( (*header_array), 'CRVAL2')
		(*i_ptr).crdelt1[i_image] = SXPAR( (*header_array), 'CRDELT1')
		(*i_ptr).crdelt2[i_image] = SXPAR( (*header_array), 'CRDELT2')
		(*i_ptr).cd1_1[i_image] = SXPAR( (*header_array), 'CD1_1')
		(*i_ptr).cd1_2[i_image] = SXPAR( (*header_array), 'CD1_2')
		(*i_ptr).cd2_1[i_image] = SXPAR( (*header_array), 'CD2_1')
		(*i_ptr).cd2_2[i_image] = SXPAR( (*header_array), 'CD2_2')
		;
		;	compute the plate scale and rotation
		;
		dy = -0.5d0 * ( (*i_ptr).cd1_2[i_image] + (*i_ptr).cd2_1[i_image])
		dx = -0.5d0 * ( (*i_ptr).cd1_1[i_image] - (*i_ptr).cd2_2[i_image])
		;
		(*i_ptr).scale[i_image] = sqrt(dx * dx + dy * dy)
		(*i_ptr).theta[i_image] = atan(dy,dx) / (!DPI / 180.0d0)
		;
		;	convert to arcmin of rotation, arcsec per pixel of plate scale
		;
		pscale = (*i_ptr).scale[i_image] * 3600.0
		ptheta = 60.0 * (*i_ptr).theta[i_image]
		;
		(*i_ptr).background[i_image] = sky
		(*i_ptr).s_background[i_image] = sigma
		;
		image_text[i_image] = this_file + '   ' +STRING(nx, ny, sky, ptheta, pscale, format='(I6.3," x",I6.3,2x,F9.1,1x,F6.1,1x,F9.5)' )
		;
		WIDGET_CONTROL, (*w_ptr).S0_images_textbox_wid,SET_VALUE=image_text[i_image],/APPEND
		;
		;	then release the heap variables
		;
		PTR_FREE, data_array, header_array, clean_array
	endfor
	;
	;	turn on some buttons and stuff
	;
	WIDGET_CONTROL, (*w_ptr).S0_crop_checkbox_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_crop_textbox_wid, SENSITIVE=0
	WIDGET_CONTROL, (*w_ptr).S0_modify_crop_button_wid, SENSITIVE=0
	;
	WIDGET_CONTROL, (*w_ptr).S0_create_mosaic_button_wid, SENSITIVE=1
	WIDGET_CONTROL, (*w_ptr).S0_match_backgrounds_checkbox_wid, SENSITIVE=1
	WIDGET_CONTROL, (*w_ptr).S0_combine_CATs_checkbox_wid, SENSITIVE=1
	WIDGET_CONTROL, (*w_ptr).S0_combine_regions_checkbox_wid, SENSITIVE=1
	;
	print_text, Event, 'All Images Read in'
	;
	;	collect all the image centers and plot them in the plot window
	;
	S0_Display_Centers, Event
	;
	SSI_end:
end
;-----------------------------------------------
;
pro S0_Display_Centers, Event
	;
	;	 determines mosaic extents, centers
	;
	;	also computes output image extents, keywords,
	;	and image center pixel offsets from output image
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	i_ptr = PTR_struct.PTR_image
	;
	;	get number of images
	;
	n_images = (*i_ptr).n_images
	;
	;	determine span of centers
	;
	span = lindgen(n_images)
	;
	;	centers
	;
	dec_center = TOTAL( (*i_ptr).crval2[span] ) / double(n_images)
	ra_center = TOTAL( (*i_ptr).crval1[span] ) / double(n_images)
	;
	;	cosine of dec at the center
	;
	cosd = cos(dec_center * (!DPI / 180.0d0))
	;
	;	modify the center offsets, using cosd from the center
	;
	for i_image = 0, n_images-1 do begin
		dcrval1 = ra_center - (*i_ptr).crval1[i_image]		; offset RA in deg
		ddcrval1 = dcrval1 * cosd
		(*i_ptr).crval1[i_image] = ra_center - ddcrval1
	endfor
	;
	;	range - include image extents
	;
	xl = fltarr(n_images)
	xh = fltarr(n_images)
	yl = fltarr(n_images)
	yh = fltarr(n_images)
	;
	for i_image = 0, n_images-1 do begin
		xl[i_image] = (*i_ptr).crval1[i_image] + (*i_ptr).cd1_1[i_image] * (*i_ptr).crpix1[i_image]	; lowest RA value
		xh[i_image] = xl[i_image] - ( (*i_ptr).nx[i_image] - 1) * (*i_ptr).cd1_1[i_image]
		;
		yl[i_image] = (*i_ptr).crval2[i_image] - (*i_ptr).cd2_2[i_image] * (*i_ptr).crpix2[i_image]
		yh[i_image] = yl[i_image] + ( (*i_ptr).ny[i_image] - 1) * (*i_ptr).cd2_2[i_image]
	endfor
	;
	;	limits
	;
	dec_low = MIN(yl)
	dec_high = MAX(yh)
	ra_low = MIN(xl)
	ra_high = MAX(xh)
	;
	;	extents in pixels
	;
	CD1_1 = TOTAL( (*i_ptr).cd1_1[span] ) / double(n_images)
	CD2_2 = TOTAL( (*i_ptr).cd2_2[span] ) / double(n_images)
	CD1_2 = TOTAL( (*i_ptr).cd1_2[span] ) / double(n_images)
	CD2_1 = TOTAL( (*i_ptr).cd2_1[span] ) / double(n_images)
	;
	o_nx = CEIL( abs(abs(ra_high - ra_low) / CD1_1) )
	o_ny = CEIL( abs(abs(dec_high - dec_low) / CD2_2) )
	;
	CRPIX1 = ROUND( (abs(ra_high - ra_center) / abs(CD1_1)) + 1)
	CRPIX2 = ROUND( (abs(dec_center - dec_low) / abs(CD2_2)) + 1)
	;
	;	get galactic coordinates of the center
	;
	year = 2000
	direction = 1
	glactc, ra_center, dec_center, year, gl_center, gb_center, direction, /degree
	print_text, Event, 'Center (L,B) = '+STRING(gl_center, gb_center, format='(F10.5,1x,f10.5)')
	;
	;	and 10 arcmin up in dec
	;
	one_arcmin = 10.0 / 60.0
	glactc, ra_center, (dec_center + one_arcmin), year, gl_one, gb_one, direction, /degree
	print_text, Event, 'Up 10 arcmindec (L,B) = '+STRING(gl_one, gb_one, format='(F10.5,1x,f10.5)')
	;
	dl = gl_one - gl_center
	db = gb_one - gb_center
	;
	gal_angle = 180.0 * atan(dl,db) / !DPI
	;
	(*i_ptr).gal_angle = gal_angle
	;
	print_text, Event, 'Gal B is to be rotated '+STRING(gal_angle, format='(F6.1)')+' degree from Dec direction'
	;
	;stop
	;
	;	ra, dec of lower left corner pixel
	;
	ra_ll = ra_center + abs( CRPIX1 - 1) * abs(CD1_1)	; the -1 is for DS9 counting first pixel as #1
	dec_ll = dec_center - abs( CRPIX2 - 1) * abs(CD2_2)
	;
	;	load the output buffer
	;
	(*i_ptr).o_nx = o_nx
	(*i_ptr).o_ny = o_ny
	(*i_ptr).o_crpix1 = CRPIX1
	(*i_ptr).o_crpix2 = CRPIX2
	(*i_ptr).o_crval1 = ra_center
	(*i_ptr).o_crval2 = dec_center
	(*i_ptr).o_cd1_1 = CD1_1
	(*i_ptr).o_cd1_2 = CD1_2
	(*i_ptr).o_cd2_1 = CD2_1
	(*i_ptr).o_cd2_2 = CD2_2
	;
	print_text, Event, 'Final Output Mosaic will be of size:'
	print_text, Event, '  (NX x NY) = '+STRING(o_nx, o_ny, format='(i5.3," x ",i5.3)')
	;
	;	reference lower left corners of each image to the lower left corner
	;	of the output image - this is the amount to add to the input images
	;	pixel coordinates to yield the output pixel coordinates
	;
	for i_image = 0, n_images - 1 do begin
		;
		(*i_ptr).xl_off[i_image] = -1L * ROUND( (abs(xh[i_image] - ra_ll) / abs(CD1_1)) ); + 1L)
		(*i_ptr).yl_off[i_image] = -1L * ROUND( (abs(dec_ll - yl[i_image]) / abs(CD2_2)) ); + 1L)
	endfor
	;
	;	and plot extents
	;
	dec_range = dec_high - dec_low
	dec_p_high = dec_high + 0.01*dec_range
	dec_p_low = dec_low - 0.01 * dec_range
	;
	ra_range = ra_high - ra_low
	ra_p_high = ra_high + 0.01 * ra_range
	ra_p_low = ra_low - 0.01 * ra_range
	;
	;	plot centers in draw window
	;
	wset, (*w_ptr).win_no_0
	device,decompose=0
	black = 10 & white = 11 & red = 12 & orange = 13 & yellow = 14 & green = 15 & blue = 16 & violet = 17 & gray = 18
	loadct, 13, /silent
	tvlct,[  0,255,255,255,255, 50,  0,148,233], $
	      [  0,255,  0,165,200,185,  0,  0,233], $
	      [  0,255,  0,  0,  0, 50,255,211,233], 10
	;
	plot, (*i_ptr).crval1[span], (*i_ptr).crval2[span], xtitle='RA [deg]', ytitle='Dec [deg]', $
			xr = [ra_p_high, ra_p_low], yr = [dec_p_low, dec_p_high], thick=1, symsize=3.0, $
			color=white, linestyle=0, /nodata
	;
	;	locate center
	;
	oplot, [ra_center], [dec_center], psym=1, thick=3, color=blue, symsize=4.0
	;
	;	and plot each image box
	;
	for i_image = 0, n_images-1 do begin
		xvec = [xh[i_image],xh[i_image],xl[i_image],xl[i_image],xh[i_image]]
		yvec = [yl[i_image],yh[i_image],yh[i_image],yl[i_image],yl[i_image]]
		oplot, xvec, yvec, psym=-2,symsize=0.001,thick=2,color=green,linestyle=2
		;
		;	and print the GP field number at its center
		;
		parts = STRSPLIT( (*i_ptr).image_filenames[i_image] , '_', /REGEX, /EXTRACT)
		num = STRTRIM(STRMID(parts[0],2),2)
		XYOUTS, (*i_ptr).crval1[i_image], (*i_ptr).crval2[i_image], num, color=red, $
			charsize=2.0, charthick=2, alignment=0.5
	endfor
	;
	;	and the full mosaic limits
	;
	xvec = [ra_high, ra_high, ra_low, ra_low, ra_high]
	yvec = [dec_low, dec_high, dec_high, dec_low, dec_low]
	oplot, xvec, yvec, psym=-2, symsize=0.0001, thick=2, color=yellow, linestyle=1
	;
	;	draw directions to galactic north (+B) and anticenter (+L)
	;
	length = 0.20 ;	deg
	ang = gal_angle * !DPI / 180.0
	x1 = length * sin(ang)
	y1 = length * cos(ang)
	oplot, [ra_center, ra_center+x1], [dec_center, dec_center+y1], psym=-2, symsize=0.001,$
				thick=2, color=orange, linestyle=1
	;
	XYoutS, (ra_center+1.1*x1), (dec_center+1.1*y1), '+B', color=orange, charsize=2.0,$
				charthick=2, alignment=0.5, orientation=gal_angle
	;
	XYoutS, (ra_center+1.2*y1), (dec_center-1.1*x1), '+L', color=orange, charsize=2.0,$
				charthick=2, alignment=0.5, orientation=gal_angle
	;
	oplot, [ra_center, ra_center+y1], [dec_center, dec_center-x1], psym=-2, symsize=0.001,$
				thick=2, color=orange, linestyle=1
	;
end
;-----------------------------------------------
pro S0_Create_Mosaic, Event
	;
	;	compute the mosaicked image
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	i_ptr = PTR_struct.PTR_image
	;
	;	process the combine files options first
	;
	;	if merge regions flag set, ask for region files
	;
	if( (*w_ptr).S0_combine_regions_flag eq 1) then S0_Combine_Regions, Event
;	if( (*w_ptr).S0_combine_cats_flag eq 1) then S0_Combine_CATs, Event
	;
	;	layer in, image-by-image
	;
	;	1. find all deleted
	;	2. subtract background from non-deleted
	;	3. at each output pixel, if deleted in output,
	;		and non-deleted in input, use input
	;	4. if both non-deleted, average by weight array
	;	5. at end, find non-deleted
	;	6. for non-deleted, add mean background
	;
	wt_array = PTR_NEW( dblarr( (*i_ptr).o_nx, (*i_ptr).o_ny ) )
	;
	n_images = (*i_ptr).n_images
	span = lindgen(n_images)
	;
	mean_background = median_filtered_mean( (*i_ptr).background[span] )
	mean_scale = median_filtered_mean( (*i_ptr).scale[span] )
	mean_theta = median_filtered_mean( (*i_ptr).theta[span] )
	;
	(*i_ptr).o_cd1_1 = -1.0d0 * mean_scale[0]
	(*i_ptr).o_cd2_2 = mean_scale[0]
	(*i_ptr).o_cd1_2 = 0.0d0
	(*i_ptr).o_cd2_1 = 0.0d0
	;
	relative_scale = float(mean_scale[0] / (*i_ptr).scale[span])
	;
	del_value = -1.0e6
	del_test = -1.0e5
	;
	;	set the hourglass
	;
	print_text, Event, 'Computing Mosaic - Please Wait'
	;
	WIDGET_CONTROL, /hourglass
	;
	;	clear output array to the deleted value
	;
	(*(*i_ptr).o_image) = fltarr( (*i_ptr).o_nx, (*i_ptr).o_ny )
	(*(*i_ptr).o_image) += del_value
	;
	for i_image = 0, n_images-1 do begin
		;
		;	read input image
		;
		image_ptr = PTR_NEW( readfits( (*i_ptr).image_pathnames[i_image],header,/silent ) )
		print_text, Event, 'Read image '+STRING(FILE_BASENAME((*i_ptr).image_pathnames[i_image]),format='(a)')
		;
		;	mask for deleted
		;
		good_mask = PTR_NEW( fltarr( (*i_ptr).nx[i_image], (*i_ptr).ny[i_image] ) )
		(*good_mask) = (*image_ptr) + 5.0e5
		(*good_mask) >= 0.0									; bad pixels have 0
		(*good_mask) <= 1.0									; good pixels have 1
		;
		;	for good pixels, remove this image's background, if match_background flag set
		;
		if( (*w_ptr).S0_match_backgrounds_flag eq 1) then $
				(*image_ptr) -= (*good_mask)*( (*i_ptr).background[i_image] )
		;
		;	reset deleted to zero before rotation and mag
		;
		(*image_ptr) *= (*good_mask)
		;
		;	then, apply mean rotation and scale to this image
		;
		new_image_ptr = PTR_NEW(/allocate_heap)
		(*new_image_ptr) = (*image_ptr)
		(*new_image_ptr) = ROT( (*image_ptr), mean_theta[0], relative_scale[i_image], MISSING=del_value,$
								CUBIC= -0.5)
		;
		;	recover deleted pixels
		;
		(*image_ptr) = (*new_image_ptr) * (*good_mask) + (1.0 - (*good_mask) ) * del_value
		;
		PTR_FREE, good_mask, new_image_ptr
		;
		;	compute the smoothed rms image and the smoothed mean image and subtract
		;
		print_text, Event, '... Computing RMS scaling array'
		make_rms_image, image_ptr, output_difference_ptr, output_rms_ptr
		;
		;	replace the input with the differenced output
		;
		(*image_ptr) = (*output_difference_ptr)
		;
		;	and turn the rms into weight, respecting bad pixels
		;
		ind_good = WHERE((*output_rms_ptr) gt 0.0,ngood,COMPLEMENT=ind_bad,NCOMPLEMENT=nbad)
		if(ngood gt 0) then begin
			(*output_rms_ptr)[ind_good] = 1./((*output_rms_ptr)[ind_good]* (*output_rms_ptr)[ind_good])
		endif
		if(nbad gt 0) then begin
			(*output_rms_ptr)[ind_bad] = 0.0
		endif
		;
		;	delete the returned output
		;
		PTR_FREE, output_difference_ptr
		;
		;	and load into the output array
		;
		for ix = 0, (*i_ptr).nx[i_image]-1 do begin
			for iy = 0, (*i_ptr).ny[i_image]-1 do begin
				;
				;	is this input pixel deleted? If so, skip over
				;
				if( (*image_ptr)[ix,iy] lt del_test or (*output_rms_ptr)[ix,iy] eq 0.0) then goto, loop_end
				;
				;	which output pixel will this input pixel go into?
				;
				iox = ix - (*i_ptr).xl_off[i_image] ;+ 1
				ioy = iy - (*i_ptr).yl_off[i_image] ;+ 1
				;
				;	what is in the output array at this location?
				;
				;	1. if the output pixel came in deleted, then do a replace & bump wt array
				;
				if( (*(*i_ptr).o_image)[iox,ioy] lt del_test) then begin
					(*(*i_ptr).o_image)[iox,ioy] = (*image_ptr)[ix,iy]
					(*wt_array)[iox,ioy] = (*output_rms_ptr)[ix,iy]
					goto, loop_end
				endif
				;
				;	if got to here, neither input nor output were deleted,
				;	so must compute weighted average of what is in output and update
				;	weight array
				;
				old_wt = (*wt_array)[iox,ioy]
				(*wt_array)[iox,ioy] += (*output_rms_ptr)[ix,iy]
				(*(*i_ptr).o_image)[iox,ioy] = ( (*(*i_ptr).o_image)[iox,ioy] * old_wt + $
						(*image_ptr)[ix,iy] * (*output_rms_ptr)[ix,iy]) / $
						(*wt_array)[iox,ioy]
				;
				loop_end:
			endfor
		endfor
		;
		PTR_FREE, image_ptr, output_rms_ptr
		;
		;	next image
		;
	endfor
	;
	;	done, release wt array
	;
	PTR_FREE, wt_array
	;
	;	return mean sky to non-deleted pixels
	;
	good_mask = PTR_NEW( fltarr( (*i_ptr).o_nx, (*i_ptr).o_ny ) )
	(*good_mask) = (*(*i_ptr).o_image) + 5.0e5
	(*good_mask) >= 0.0									; bad pixels have 0
	(*good_mask) <= 1.0									; good pixels have 1
	;
	;	for good pixels, remove this image's background
	;
	ave_background = FLOAT(mean_background[0])
	;
	if( (*w_ptr).S0_match_backgrounds_flag eq 1) then $
		(*(*i_ptr).o_image) += (*good_mask) * ave_background
	;
	PTR_FREE, good_mask
	;
	;	turn on some buttons and stuff
	;
	WIDGET_CONTROL, (*w_ptr).S0_write_FITS_button_wid, SENSITIVE=1
	WIDGET_CONTROL, (*w_ptr).S0_rotate_to_galactic_checkbox_wid, SENSITIVE=1
	WIDGET_CONTROL, (*w_ptr).S0_offset_slider_wid, SENSITIVE=1
	WIDGET_CONTROL, (*w_ptr).S0_range_slider_wid, SENSITIVE=1
	WIDGET_CONTROL, (*w_ptr).S0_write_TIFF_button_wid, SENSITIVE=1
	WIDGET_CONTROL, (*w_ptr).S0_display_regions_checkbox_wid, SENSITIVE=1
	WIDGET_CONTROL, (*w_ptr).S0_display_image_button_wid, SENSITIVE=1
	WIDGET_CONTROL, (*w_ptr).S0_display_histogram_button_wid, SENSITIVE=1
	WIDGET_CONTROL, (*w_ptr).S0_scale_method_droplist_wid, SENSITIVE=1
	WIDGET_CONTROL, (*w_ptr).S0_lut_droplist_wid, SENSITIVE=1
	;
	print_text, Event, 'Mosaic Completed'
	;
end
;-----------------------------------------------
pro S0_Write_FITS, Event
	;
	;	writes the output mosaic as a FITS image
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	i_ptr = PTR_struct.PTR_image
	;
	file_out = dialog_pickfile(Title="Output Mosaic FITS Image")
	;
	;	steal one of the fits headers, then update with
	;	mosaic info
	;
	header = headfits( (*i_ptr).image_pathnames[0],/silent)
	;
	sxaddpar, header, 'CRPIX1', (*i_ptr).o_crpix1
	sxaddpar, header, 'CRPIX2', (*i_ptr).o_crpix2
	sxaddpar, header, 'CRVAL1', (*i_ptr).o_crval1
	sxaddpar, header, 'CRVAL2', (*i_ptr).o_crval2
	sxaddpar, header, 'CD1_1',  (*i_ptr).o_cd1_1
	sxaddpar, header, 'CD1_2',  (*i_ptr).o_cd1_2
	sxaddpar, header, 'CD2_1',  (*i_ptr).o_cd2_1
	sxaddpar, header, 'CD2_2',  (*i_ptr).o_cd2_2
;
	writefits, file_out, (*(*i_ptr).o_image), header
	;
	print_text, Event, 'FITS Mosaic written to disk'
	;
end
;-----------------------------------------------
pro S0_Write_TIFF, Event
	;
	;	writes an output TIFF type image
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	i_ptr = PTR_struct.PTR_image
	;
	;	create a working copy of the mosaic
	;
	tiff_ptr = PTR_NEW( fltarr( (*i_ptr).o_nx, (*i_ptr).o_ny ) )
	;
	;	and load it
	;
	(*tiff_ptr) = (*(*i_ptr).o_image)
	;
	;	load the correct lookup table, preserving space for special colors at the bottom
	;
	case (*w_ptr).S0_lut of
		'Rainbow':	ilut = 13
		'Gray Scale': ilut = 0
		'Red BB': ilut = 3
		'Inverse Gray': ilut = 0
	endcase
	;
	loadct, ilut, RGB_TABLE = rgb_table	; fetch the lookup table
	;
	;	if inverse gray, invert the table
	;
	offset = 9 	; next one to load into
	;
	if( (*w_ptr).S0_lut eq 'Inverse Gray') then begin
		ncolors = !D.TABLE_SIZE
		new_rgb_table = rgb_table * 0B
		for ic = 0, (ncolors-offset-1) do begin
			new_rgb_table[ic+offset,*] = rgb_table[ncolors-offset-1-ic,*]
		endfor
		;
		rgb_table = new_rgb_table
	endif
	;
	;	load the special colors
	;
	;	cyan, yellow, magenta, red, green, blue, orange, black, white
	;
	special = byte([  0,255,255,	255,255,0,  255,0,255, $
	  		   	   255, 0,  0,	0,255,0,  	0,  0,255, $
	  		   	255, 153,  0,  	0,  0, 0,	255,255,255])
	;
	for i=0,offset-1 do begin
		rgb_table[i,0] = special[i*3]
		rgb_table[i,1] = special[i*3 + 1]
		rgb_table[i,2] = special[i*3 + 2]
	endfor
	;
	;	scale image from h_lower to h_upper using desired scaling method
	;
	low_cut = (*i_ptr).h_lower
	range = (*i_ptr).h_upper
	;
	case (*w_ptr).S0_scale_method of
		'Linear': 	begin
						(*tiff_ptr) = ((*tiff_ptr) - low_cut) / range	; fractional, now
					end
		'Log':		begin
						(*tiff_ptr) = alog10( (*tiff_ptr) - low_cut ) / alog10(range)
					end
		'Sqrt':		begin
						(*tiff_ptr) = sqrt( (*tiff_ptr) - low_cut) / sqrt(range)
					end
	endcase
	;
	;	scale to offset-255
	;
	b_range = 255 - offset
	;
	(*tiff_ptr) *= b_range
	(*tiff_ptr) += offset
	(*tiff_ptr) >= offset
	(*tiff_ptr) <= 255.0
	;
	;	and convert to byte form
	;
	(*tiff_ptr) = byte( (*tiff_ptr) )
	;
	;	layer on regions here, if (1) there are regions and (2) overlay was requested
	;
	if((*w_ptr).S0_display_regions_flag eq 1) then begin
		nregions = N_ELEMENTS( (*(*i_ptr).o_region) )
		if(nregions gt 0) then begin
			print_text, Event, 'Writing '+STRING(nregions,format='(I7.1)')+' regions to TIFF image'
			;
			WIDGET_CONTROL, /hourglass
			;
			S0_Overlay_Regions, Event, tiff_ptr
		endif
	endif
	;
	;	then perform a vertical flip
	;
	print_text, Event, 'Flipping TIFF vertically'
	WIDGET_CONTROL, /hourglass
	;
	new_ptr = PTR_NEW(bytarr( (*i_ptr).o_nx, (*i_ptr).o_ny ) )
	;
	for iy = 0, (*i_ptr).o_ny-1 do begin
		(*new_ptr)[*,iy] = (*tiff_ptr)[*,(*i_ptr).o_ny -1 -iy]
	endfor
	;
	;	release tiff-ptr
	;
	PTR_FREE, tiff_ptr
	;
	;	if rotate flag set...
	;
	if( (*w_ptr).S0_rotate_to_galactic_flag eq 1) then begin
		;
		;	compute expansion needed to account for rotation
		;
		S0_Expansion_from_Rotation, Event, expansion_factor
		;
		;	create larger, white background image within which to put TIFF
		;
		new_nx = long((*i_ptr).o_nx * expansion_factor)
		new_ny = long((*i_ptr).o_ny * expansion_factor)
		;
		x_off = (new_nx - (*i_ptr).o_nx)/2
		y_off = (new_ny - (*i_ptr).o_ny)/2
		;
		big_ptr = PTR_NEW( bytarr(new_nx, new_ny) )
		(*big_ptr)[*,*] = 8B
		;
		(*big_ptr)[x_off:x_off+(*i_ptr).o_nx-1,y_off:y_off+(*i_ptr).o_ny-1] = (*new_ptr)[*,*]
		;
		;	rotate (no scaling)
		;
		PTR_FREE, new_ptr
		new_ptr = PTR_NEW(/allocate_heap)
		;
		print_text, Event, 'Rotating TIFF'
		WIDGET_CONTROL, /hourglass
		;
		(*new_ptr) = ROT( (*big_ptr), (*i_ptr).gal_angle, $
;						/INTERP, $
						MISSING=8B )
		;
		PTR_FREE, big_ptr
		;
		print_text, Event, 'TIFF image rotation complete'
	endif
	;
	;	write as tiff file
	;
	file_out = dialog_pickfile(Title='Tiff image')
	;
	write_tiff, file_out, (*new_ptr), RED=REFORM(rgb_table[*,0]), $
			GREEN=REFORM(rgb_table[*,1]), BLUE=REFORM(rgb_table[*,2])
			;
	;
	PTR_FREE, new_ptr
	;
	print_text, Event, 'Tiff File '+FILE_BASENAME(file_out)+' written to disk'
	;
end
;-----------------------------------------------
pro S0_Change_LUT, ilut, Event
	;
	;	get a new value from one of the sliders to modify the display lookup table
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	;
	case ilut of
		0: begin
			WIDGET_CONTROL, (*w_ptr).S0_offset_slider_wid, GET_VALUE=the_value
			(*w_ptr).S0_offset_slider_value = the_value
;			print_text, Event, 'New offset slider value = '+STRING(the_value)
		   end
		1: begin
			WIDGET_CONTROL, (*w_ptr).S0_range_slider_wid, GET_VALUE= the_value
			(*w_ptr).S0_range_slider_value = the_value
;			print_text, Event, 'New range slider value = '+STRING(the_value)
		   end
	endcase
	;
	;	and reissue the last display command (either histo or plot)
	;
	case (*w_ptr).S0_last_display of
		'histo': S0_Display_Histogram, Event
		'image': S0_Display_Image, Event
		else: print_text, Event, 'No display requested'
	endcase
	;
end
;-----------------------------------------------
pro S0_Display_Image, Event
	;
	;	display a portion of the mosaic to the draw window
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	i_ptr = PTR_struct.PTR_image
	;
	;	get geometry of draw window
	;
	geo = WIDGET_INFO( (*w_ptr).S0_draw_window_wid, /GEOMETRY )
	;
	;	drawable number of x, y pixels
	;
	d_nx = round(geo.scr_xsize)
	d_ny = round(geo.scr_ysize)
	;
	print_text, Event, 'Displaying center '+STRING(d_nx, d_ny,format='(I5.1," x ",I5.1)')+' pixels of mosaic'
	;
	;	select this many pixels from the center of the mosaic
	;
	d_nx2 = Round(d_nx/2)
	d_ny2 = Round(d_ny/2)
	;
	x0 = round((*i_ptr).o_nx / 2) - d_nx2
	x1 = round(x0 + d_nx - 1)
	y0 = round((*i_ptr).o_ny / 2) - d_ny2
	y1 = round(y0 + d_ny - 1)
	;
	;	save these
	;
	(*i_ptr).d_xl = x0
	(*i_ptr).d_yl = y0
	(*i_ptr).d_xu = x1
	(*i_ptr).d_yu = y1
	;
	sub_ptr = PTR_NEW( (*(*i_ptr).o_image)[x0:x1,y0:y1] )
	;
	;	get offset, range from sliders
	;
	zz = median_filtered_mean( (*sub_ptr) )
	print_text, Event, 'Mean, sigma = '+STRING(zz[0],zz[1],format='(F12.1,", ",F6.1)')
	;
	;	fetch slider values
	;
	case (*w_ptr).S0_scale_method of
		'Linear': 	begin
						h_max = (zz[0]+50.0*zz[1])
						range = h_max * (float( (*w_ptr).S0_range_slider_value ) / 255.0) ; range 1 to 1001 sigma
					end
		'Log': 		begin
						h_max = MAX( (*sub_ptr) ) / 500.0
						range = h_max * 100.0^((float( (*w_ptr).S0_range_slider_value ) / 255.0)) ; range 1 to 1001 sigma
					end
		'Sqrt': 	begin
						h_max = MAX( (*sub_ptr) ) / 5.0
						range = h_max * (float( (*w_ptr).S0_range_slider_value ) / 255.0)^2 ; range 1 to 1001 sigma
					end
		else:		print_text, Event, 'Y-scaling method not recognized in draw histogram'
	endcase
	;
	offset = -2.0 + 10.0* (float( (*w_ptr).S0_offset_slider_value ) / 255.0) ; offset +/- 10 sigma
;	range = h_max * (float( (*w_ptr).S0_range_slider_value ) / 255.0) ; range 1 to 1001 sigma
	;	set lower limit to mean - 2 sigma, upper to mean + 10 sigma
	;
	(*i_ptr).h_lower = zz[0] + offset * zz[1]
	(*i_ptr).h_upper = (*i_ptr).h_lower + range
	;
	;	echo
	;
	print_text, Event, 'Lower = '+STRING( (*i_ptr).h_lower, format='(F10.1)')
	print_text, Event, 'Upper = '+STRING( (*i_ptr).h_upper, format='(F10.1)')
	;
	wset, (*w_ptr).win_no_0
	device,decompose=0
	black = 10 & white = 11 & red = 12 & orange = 13 & yellow = 14 & green = 15 & blue = 16 & violet = 17 & gray = 18
	case (*w_ptr).S0_lut of
		'Rainbow': loadct, 13, /silent
		'Gray Scale': loadct, 0, /silent
		'Red BB': loadct, 3, /silent
		'Inverse Gray': begin
							loadct, 0, RGB_TABLE=lut_table		; get the LUT
							ncolors = !D.TABLE_SIZE
							new_lut_table = lut_table * 0
							for i = 0, ncolors-1 do new_lut_table[i,*] = lut_table[ncolors-1-i,*]
						 	tvlct, new_lut_table
						end
		else: print_text, Event, "ERROR - LUT selection not recognized"
	endcase
	;
	disp_ptr = PTR_NEW( (*sub_ptr) - (*i_ptr).h_lower )  ;		reference to lower level
	;
	;	if linear scaling:
	;
	case (*w_ptr).S0_scale_method of
		'Linear' : begin
						scaled_range = 253 / (range)				 ; 		scale, relative to slider range
						(*disp_ptr) *= scaled_range
				   end
		'Log': 	   begin
						scaled_range = 253 / (alog10(range))
				   		(*disp_ptr) = alog10( (*disp_ptr))
				   		(*disp_ptr) *= scaled_range
		           end
		'Sqrt':    begin
						scaled_range = 253 / (sqrt(range))
						(*disp_ptr) = sqrt( (*disp_ptr) )
						(*disp_ptr) *= scaled_range
		           end
		else: 	   begin
					print_text, Event, 'ERROR - scaling method not understood in display image'
					goto, SDI_end
				   end
	endcase
	;
;	(*disp_ptr) >= 0.0
;	(*disp_ptr) <= 253.0
	;
	displ = byte(1)+bytscl( (*disp_ptr),min=0,max=254,top=253)
	;
	tv, displ
	;
	PTR_FREE, disp_ptr, sub_ptr
	;
	;	set last display to 'image'
	;
	(*w_ptr).S0_last_display = 'image'
	;
	SDI_end:
end
;----------------------------------------------
pro S0_Display_Histogram, Event
	;
	;	display histogram of mosaic values to the draw window, permit sliders to select region to
	;	enhance in display
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	i_ptr = PTR_struct.PTR_image
	;
	;	select a subset of mosaic values, but ignore all deleted data
	;
	sub_ptr = PTR_NEW(/allocate_heap)
	;
	(*sub_ptr) = (*(*i_ptr).o_image)[0:(*i_ptr).o_nx-1:25,0:(*i_ptr).o_ny-1:25]
	;
	ind_good = WHERE( (*sub_ptr) gt -1.0e4, ngood)
	if(ngood gt 0) then (*sub_ptr) = (*sub_ptr)[ind_good]
	;
	zz = median_filtered_mean( (*sub_ptr) )
	print_text, Event, 'Mean, sigma = '+STRING(zz[0],zz[1],format='(F12.1,", ",F6.1)')
	;
	;	fetch slider values
	;
	case (*w_ptr).S0_scale_method of
		'Linear': 	h_max = (zz[0]+50.0*zz[1])
		'Log': 		h_max = MAX( (*sub_ptr) ) / 5.0
		'Sqrt': 	h_max = MAX( (*sub_ptr) ) / 10.0
		else:		print_text, Event, 'Y-scaling method not recognized in draw histogram'
	endcase
	;
	offset = -2.0 + 10.0* (float( (*w_ptr).S0_offset_slider_value ) / 255.0) ; offset -2 to +8 sigma
	range = h_max * (float( (*w_ptr).S0_range_slider_value ) / 255.0) ; range 1 to 1001 sigma
	;	set lower limit to mean - 2 sigma, upper to mean + 10 sigma
	;
	(*i_ptr).h_lower = zz[0] + offset * zz[1]
	(*i_ptr).h_upper = (*i_ptr).h_lower + range
	;
	;	echo
	;
	print_text, Event, 'Lower = '+STRING( (*i_ptr).h_lower, format='(F10.1)')
	print_text, Event, 'Upper = '+STRING( (*i_ptr).h_upper, format='(F10.1)')
	;
	;	form the histogram
	;
	nbins = 100
	case (*w_ptr).S0_scale_method of
		'Linear': 	h_max = (zz[0]+50.0*zz[1])
		'Log': 		h_max = MAX( (*sub_ptr) ) / 5.0
		'Sqrt': 	h_max = MAX( (*sub_ptr) ) / 10.0
		else:		print_text, Event, 'Y-scaling method not recognized in draw histogram'
	endcase
	yhisto = HISTOGRAM( (*sub_ptr), MIN=(zz[0]-2.0*zz[1]), MAX=h_max, $
				NBINS=nbins, LOCATIONS=xhisto)
	;
	;	center up the x values
	;
	dx = xhisto[1] - xhisto[0]
	xhisto += dx/2.0
	;
	xmin = xhisto[0]
	xmax = xhisto[nbins-1]
	xrange = xmax - xmin
	xmin = xmin - 0.02*xrange
	xmax = xmax + 0.02*xrange
	;
	case (*w_ptr).S0_scale_method of
		'Linear': 	begin
						scale_method = ''
					end
		'Log': 		begin
						yhisto = alog10(yhisto)
						ind_bad = WHERE( ~finite(yhisto), nbad)
						if(nbad gt 0) then yhisto[ind_bad] = 0.0
						scale_method = 'Log'
					end
		'Sqrt': 	begin
						yhisto = alog10(yhisto)
						ind_bad = WHERE( ~finite(yhisto), nbad)
						if(nbad gt 0) then yhisto[ind_bad] = 0.0
						scale_method = 'Log'
					end
		else:		print_text, Event, 'Y-scaling method not recognized in draw histogram'
	endcase
	;
	ymin = 0.
	ymax = MAX(yhisto)
	yrange = ymax - ymin
	ymin = (ymin - 0.02*yrange) > 0.0
	ymax = ymax + 0.02*yrange
	;
	;	limit the marker values to these x limits
	;
;	(*i_ptr).h_lower >= xhisto[0]
;	(*i_ptr).h_upper <= xhisto[nbins-1]
	;
	;	clear the plot window and plot to it.
	;
	wset, (*w_ptr).win_no_0
	device,decompose=0
	black = 10 & white = 11 & red = 12 & orange = 13 & yellow = 14 & green = 15 & blue = 16 & violet = 17 & gray = 18
	loadct, 13, /silent
	tvlct,[  0,255,255,255,255, 50,  0,148,233], $
	      [  0,255,  0,165,200,185,  0,  0,233], $
	      [  0,255,  0,  0,  0, 50,255,211,233], 10
	;
	plot, xhisto, yhisto, xtitle='Pixel Value [ADUs]', ytitle=scale_method+'(Number)', $
			xr = [xmin, xmax], yr = [ymin, ymax], thick=1, symsize=3.0, $
			color=white, linestyle=0, /nodata, xstyle=1
	;
	;	plot histo
	;
	oplot, xhisto, yhisto, psym=10, thick=2, color=blue
	;
	;	and the lower, upper limits
	;
	oplot, [(*i_ptr).h_lower, (*i_ptr).h_lower], [ymin, ymax], color=green, thick=3, linestyle=2, $
				psym=-1, symsize=0.001
	oplot, [(*i_ptr).h_upper, (*i_ptr).h_upper], [ymin, ymax], color=red, thick=3, linestyle=2, $
				psym=-1, symsize=0.001
	;
	;	set flag about last thing displayed
	;
	(*w_ptr).S0_last_display = 'histo'
	;
	PTR_FREE, sub_ptr
end
;----------------------------------------------
pro S0_Combine_Regions, Event
	;
	;	collect all the region files and combine them into one region file
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	i_ptr = PTR_struct.PTR_image
	;
	;	get pathnames to region files
	;
	region_pathnames = dialog_pickfile(Title='Select Region Files',/MULTIPLE_FILES)
	n_files = N_ELEMENTS(region_pathnames)
	if(n_files eq 0) then begin
		print_text, Event, 'No region files selected. Will not write a combined region file'
		goto, SCR_end
	endif
	;
	;	sort by name, which should put them in same order as images
	;
	ind_sort = SORT(region_pathnames)
	region_pathnames = region_pathnames[ind_sort]
	;
	;	for each file
	;
	for i_file = 0, n_files-1 do begin
		;
		;	recover the amount to add to the x and y coordinates to
		;	correct onto the mosaic file
		;
		xl_off = -1.0*(*i_ptr).xl_off[i_file] + 1.0
		yl_off = -1.0*(*i_ptr).yl_off[i_file] + 1.0
		;
		;	open a region file
		;
		openr, lu_reg, region_pathnames[i_file], /GET_LUN
		;
		;	and read each line
		;
		this_ptr = PTR_NEW(/allocate_heap)
		;
		linenum = 1
		legend = 0
		while ~EOF(lu_reg) do begin
			line = ''
			readf, lu_reg, line
			;
			;	if no legend yet found, look for 'text' and 'white' in line
			;
			leg = STRPOS(line, 'text')
			if(leg ne -1) then begin
				leg_2 = STRPOS(line, 'white')
				if(leg_2 ne -1) then begin
					if(legend eq 0) then begin
						legend++
					endif else goto, skip_line
				endif
			endif
			;
			;	parse, 1st by #
			;
			parts = STRSPLIT(line, '#', /REGEX, /EXTRACT)
			nparts = N_ELEMENTS(parts)
			if(nparts ne 2) then begin
				;
				;	either no # or multiple # signs
				;
				if(nparts lt 2) then begin
					print_text, Event, 'ERROR - found a bad line ('+STRING(linenum,format='(I5.1)')+$
								') in reg file '+FILE_BASENAME(region_pathnames[i_file])
					goto, skip_line
				endif
				;
				;	multiple # signs, for now, merge any beyond 1st
				;
				print_text, Event, 'Warning - found multiple # signs in reg file, keeping'
				for ipts = 3, nparts do begin
					parts[1] = parts[1] + ' # ' + parts[ipts-1]
				endfor
			endif
			;
			;	then, interpret first set
			;
			sub_parts = STRSPLIT(parts[0], ' ', /REGEX, /EXTRACT)
			n_sub = N_ELEMENTS(sub_parts)
			;
			;	circle has 4 parts, line has 5 parts
			;
			if(n_sub eq 4) then begin
				;
				;	check that this is a circle
				;
				if(STRUPCASE(STRTRIM(sub_parts[0],2)) eq 'CIRCLE') then begin
					;
					;	yes, fetch X_c and Y_c
					;
					X_c = float(sub_parts[1])
					Y_c = float(sub_parts[2])
					R_c = float(sub_parts[3])
					;
					;	apply offsets
					;
					X_c += xl_off
					Y_c += yl_off
					;
					;	and pack back into line
					;
					line = 'circle '+STRING(X_c, Y_c, R_c, format='(F8.1,1x,F8.1,1x,F6.1)')
				endif else begin
					print_text, Event, 'ERROR parsing region entry at line ('+$
						STRING(linenum,format='(I5.1)')+') = '+parts[0]
					goto, skip_line
				endelse
			endif
			;
			if(n_sub eq 5) then begin
				;
				;	check that this is a line
				;
				if(STRUPCASE(STRTRIM(sub_parts[0],2)) eq 'LINE') then begin
					;
					;	yes, fetch X_0, Y_0, X_1, and Y_1
					;
					X_0 = float(sub_parts[1])
					Y_0 = float(sub_parts[2])
					X_1 = float(sub_parts[3])
					Y_1 = float(sub_parts[4])
					;
					;	apply offsets
					;
					X_0 += xl_off
					Y_0 += yl_off
					X_1 += xl_off
					Y_1 += yl_off
					;
					;	and pack back into line
					;
					line = 'line '+STRING(X_0, Y_0, X_1, Y_1, format='(F8.1,1x,F8.1,1x,F8.1,1x,F8.1)')
				endif else begin
					print_text, Event, 'ERROR parsing region entry at line ('+$
						STRING(linenum,format='(I5.1)')+') = '+parts[0]
					goto, skip_line
				endelse
			endif
			;
			if(n_sub lt 4 or n_sub gt 5) then begin
				;
				;	if got to here, then neither circle nor line - write error
				;
				print_text, Event, 'ERROR parsing region entry at line ('+$
							STRING(linenum,format='(I5.1)')+') = '+parts[0]
				goto, skip_line
			endif
			;
			;	otherwise, put line buffer back together
			;
			line = line + ' # ' + parts[1]
			;
			;	and add to the local region file
			;
			if(linenum eq 1) then begin
				linenum++
				(*this_ptr) = strarr(1)
				(*this_ptr)[0] = line
			endif else begin
				(*this_ptr) = [ (*this_ptr), line]
			endelse
			;
			skip_line:
			;
		endwhile
		FREE_LUN, lu_reg
		;
		;	and put onto the global region file
		;
		if(i_file eq 0) then begin
			(*(*i_ptr).o_region) = (*this_ptr)
		endif else begin
			(*(*i_ptr).o_region) = [ (*(*i_ptr).o_region), (*this_ptr)]
		endelse
		;
		PTR_FREE, this_ptr
		;
		print_text, Event, 'Finished reading region file '+FILE_BASENAME(region_pathnames[i_file])
	endfor
	;
	nlines = N_ELEMENTS( (*(*i_ptr).o_region) )
	;
	print_text, Event, 'Full region file accumulated, with '+STRING(nlines,format='(I8.1)')+' lines'
	;
	;	turn on the button to enable writing the combined region array as a file
	;
	WIDGET_CONTROL, (*w_ptr).S0_write_region_file_button_wid, SENSITIVE=1
	;
	SCR_end:
	;
end
;-------------------------------------------------------------------------------
pro S0_Write_Region_File, Event
	;
	;	writes the region file
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	i_ptr = PTR_struct.PTR_image
	;
	file_out = dialog_pickfile(Title='Mosaic Region File')
	;
	openw, lu_reg, file_out, /GET_LUN
	;
	nlines = N_ELEMENTS(  (*(*i_ptr).o_region) )
	;
	for i = 0, nlines-1 do begin
		printf, lu_reg, (*(*i_ptr).o_region)[i], format='(a)'
	endfor
	;
	FREE_LUN, lu_reg
	;
	print_text, Event, 'Mosaic Region File '+FILE_BASENAME(file_out)+' written.'
end
;-----------------------------------------------------------------
pro S0_Draw_Vector, image_ptr, coords, color_index
;
;	for an image (pointed to by a pointer), draws a stick vector between
;	coords.x0, .y0 and .x1, .y1 of color_index
;
;	image is byte type, same as color_index
;
;	will not draw outside image
;
;	DPC	20110106
;
image_size = SIZE( (*image_ptr) )
nx = image_size[1]
ny = image_size[2]
;
;	test that at least one end point is within
;	image
;
iloop = 0
;
new_coords = coords
;
restart:
;
n_in = intarr(4)
if(new_coords.x0 ge 0 and new_coords.x0 le (nx-1)) then begin
	n_in[0] = 1
	if(new_coords.y0 ge 0 and new_coords.y0 le (ny-1)) then n_in[1] = 1
endif
if(new_coords.x1 ge 0 and new_coords.x1 le (nx-1)) then begin
	n_in[2] = 1
	if(new_coords.y1 ge 0 and new_coords.y1 le (ny-1)) then n_in[3] = 1
endif
;
if(TOTAL(n_in) eq 0) then goto, the_end
;
;  slope, offset
;
denom = float(new_coords.x1 - new_coords.x0)
if(abs(denom) lt 0.001) then denom = 0.001
;
slope = float(new_coords.y1 - new_coords.y0) / denom
offset = float(new_coords.y0) - slope * float(new_coords.x0)
;
if(TOTAL(n_in) ne 4) then begin
	;
	;	only 1 in image, need to interpolate to
	;	create new point on image boundary
	;
	;	out in x or y?
	;
	if((n_in[0]+n_in[2]) ne 2) then begin
		;
		;	x
		;
		;	which point is outside image?
		;
		if(n_in[0] eq 0) then begin
			;
			;	x0
			;
			if(new_coords.x0 lt 0) then begin
				;
				;	too negative
				;
				new_coords.x0 = 0		; reset to boundary
				new_coords.y0 = offset
				;
			endif else begin
				;
				;	too positive
				;
				new_coords.x0 = nx-1
				new_coords.y0 = offset + slope * (nx-1)
			endelse
		endif else begin
			;
			;	x1
			;
			if(new_coords.x1 lt 0) then begin
				;
				;	too negative
				;
				new_coords.x1 = 0
				new_coords.y1 = offset
				;
			endif else begin
				;
				;	too postiive
				;
				new_coords.x1 = nx-1
				new_coords.y1 = offset + slope * (nx-1)
			endelse
		endelse
	endif else begin
		;
		;	y
		;
		if(n_in[1] eq 0) then begin
			;
			;	y0
			;
			if(new_coords.y0 lt 0) then begin
				;
				new_coords.y0 = 0
				new_coords.x0 = -1.0 * offset / slope
			endif else begin
				new_coords.y0 = ny-1
				new_coords.x0 = ((ny - 1) - offset) / slope
			endelse
		endif else begin
			;
			;	y1
			;
			if(new_coords.y1 lt 0) then begin
				new_coords.y1 = 0
				new_coords.x1 = -1.0 * offset / slope
			endif else begin
				new_coords.y1 = ny-1
				new_coords.x1 = ((ny-1)-offset)/slope
			endelse
		endelse
	endelse
	;
	;	increment loop, restart if under 4
	;
	iloop++
	if(iloop le 4) then goto, restart else goto, the_end
	;
endif
;
;	at this point, have good vector coordinates within
;	this image
;
;	for the subimage spanned by the x and y limits
;
x0 = round(new_coords.x0)
x1 = round(new_coords.x1)
y0 = round(new_coords.y0)
y1 = round(new_coords.y1)
;
xl = x0 < x1
xu = x0 > x1
yl = y0 < y1
yu = y0 > y1
;
for ix = xl, xu do begin
	for iy = yl, yu do begin
		;
		;	how far is this pixel from the line?
		;
		;	change the slope, then use this point to derive a new line
		;
		if(abs(slope) gt 1000.0) then new_slope = 0.0 else new_slope = -1.0/slope
		;
		new_offset = float(iy) - new_slope * float(ix)
		;
		;	solve for intersection of the two lines
		;
		x_pt = -1.0* (offset - new_offset) / (slope - new_slope)
		y_pt = slope * x_pt + offset
		;
		;	how far is our pixel from the intersection?
		;
		dist = sqrt((float(ix) - x_pt)^2 + (float(iy) - y_pt)^2)
		;
		;	if distance is under root2 pixel, light it up
		;
		;print, 'ix, iy, dist = ',ix, iy, dist
		;
		if(dist le 0.71) then begin
			(*image_ptr)[ix,iy] = color_index
		endif
	endfor
endfor
;
;	done!
;
the_end:
;
end
;----------------------------------------------------------
pro S0_Draw_Circle, image_ptr, coords, color_index
;
;	for the indicated image, goes to coords.x0, .y0
;	and draws a circle of the color_index for radius
;	.r
;
;	will not draw outside image
;
;	DPC	20110106
;
image_size = SIZE( (*image_ptr) )
nx = image_size[1]
ny = image_size[2]
;
;	test that the center is on the image
;
new_coords = coords
;
if(new_coords.x0 lt 0 or new_coords.x0 gt (nx-1)) then goto, the_end
if(new_coords.y0 lt 0 or new_coords.y0 gt (ny-1)) then goto, the_end
;
;	for a box around the current coordinates
;
rbox = round( new_coords.r ) + 2
;
x_0 = round(((new_coords.x0 - rbox) > 0) < (nx-1))
x_1 = round(((new_coords.x0 + rbox) > 0) < (nx-1))
y_0 = round(((new_coords.y0 - rbox) > 0) < (ny-1))
y_1 = round(((new_coords.y0 + rbox) > 0) < (ny-1))
;
for ix = x_0, x_1 do begin
	for iy = y_0, y_1 do begin
		;
		;	distance from this pixel to the center?
		;
		dist = sqrt( (float(ix) - new_coords.x0)^2 + (float(iy) - new_coords.y0)^2)
		;
		ddist = abs(dist - new_coords.r)
		;
		if(ddist lt 0.4999) then (*image_ptr)[ix,iy] = color_index
	endfor
endfor
;
the_end:
;
end
;------------------------------------------------------------
pro S0_Overlay_Regions, Event, tiff_ptr
	;
	;	loads the regions onto the tiff image
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	i_ptr = PTR_struct.PTR_image
	;
	nregions = N_ELEMENTS( (*(*i_ptr).o_region) )
	;
	;	for each region, read the line and parse for
	;	type, coords
	;
	for ireg = 0, nregions-1 do begin
		line = (*(*i_ptr).o_region)[ireg]
		;
		;	parse, 1st by #
		;
		parts = STRSPLIT(line, '#', /REGEX, /EXTRACT)
		nparts = N_ELEMENTS(parts)
		if(nparts ne 2) then begin
			;
			;	either no # or multiple # signs
			;
			if(nparts lt 2) then begin
				print_text, Event, 'ERROR - found a bad line ('+STRING(linenum,format='(I5.1)')+$
							') in reg file '+FILE_BASENAME(region_pathnames[i_file])
				goto, skip_line
			endif
			;
			;	multiple # signs, for now, merge any beyond 1st
			;
			print_text, Event, 'Warning - found multiple # signs in reg file, keeping'
			for ipts = 3, nparts do begin
				parts[1] = parts[1] + ' # ' + parts[ipts-1]
			endfor
		endif
		;
		;	then, interpret first set
		;
		sub_parts = STRSPLIT(parts[0], ' ', /REGEX, /EXTRACT)
		n_sub = N_ELEMENTS(sub_parts)
		;
		;	circle has 4 parts, line has 5 parts
		;
		if(n_sub eq 4) then begin
			;
			;	check that this is a circle
			;
			if(STRUPCASE(STRTRIM(sub_parts[0],2)) eq 'CIRCLE') then begin
				;
				;	yes, fetch X_c and Y_c
				;
				X_c = double(sub_parts[1])
				Y_c = double(sub_parts[2])
				R_c = double(sub_parts[3])
				;
				coords = {x0:X_c, y0:Y_c, r: R_c}
				;
				;	and call circle drawer
				;
				color_index = 7B		; black for now
				;
				S0_Draw_Circle, tiff_ptr, coords, color_index
				;
			endif else begin
				print_text, Event, 'ERROR parsing region entry at line ('+$
					STRING(linenum,format='(I5.1)')+') = '+parts[0]
				goto, skip_line
			endelse
		endif
		;
		if(n_sub eq 5) then begin
			;
			;	check that this is a line
			;
			if(STRUPCASE(STRTRIM(sub_parts[0],2)) eq 'LINE') then begin
				;
				;	yes, fetch X_0, Y_0, X_1, and Y_1
				;
				X_0 = double(sub_parts[1])
				Y_0 = double(sub_parts[2])
				X_1 = double(sub_parts[3])
				Y_1 = double(sub_parts[4])
				;
				coords = {x0:X_0, y0:Y_0, x1:X_1, y1:Y_1}
				color_index = 7B
				;
				S0_Draw_Vector, tiff_ptr, coords, color_index
				;
			endif else begin
				print_text, Event, 'ERROR parsing region entry at line ('+$
					STRING(linenum,format='(I5.1)')+') = '+parts[0]
				goto, skip_line
			endelse
		endif
		;
		if(n_sub lt 4 or n_sub gt 5) then begin
			;
			;	if got to here, then neither circle nor line - write error
			;
			print_text, Event, 'ERROR parsing region entry at line ('+$
						STRING(linenum,format='(I5.1)')+') = '+parts[0]
			goto, skip_line
		endif
		;
		skip_line:
		;
	endfor
	;
	print_text, Event, 'Finished writing regions to tiff image'
	;
end
;--------------------------------------------------------------------------
pro S0_Expansion_from_Rotation, Event, expansion_factor
	;
	;	compute the image size to expand by to
	;	keep the rotated image within the total
	;	image boundary
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	w_ptr = PTR_struct.PTR_wid_id
	i_ptr = PTR_struct.PTR_image
	;
	nx = (*i_ptr).o_nx
	ny = (*i_ptr).o_ny
	;
	angle = (*i_ptr).gal_angle
	r_angle = angle * !DPI / 180.0
	;
	;-------------------------------------------------
	;
	;	ur corner, from center
	;
	ur_x = nx / 2.0
	ur_y = ny / 2.0
	;
	ul_x = -ur_x
	ul_y = ur_y
	;
	;	rotate CCW
	;
	new_xr = ur_x * cos(r_angle) - ur_y * sin(r_angle)
	new_yr = ur_y * cos(r_angle) + ur_x * sin(r_angle)
	;
	new_xl = ul_x * cos(r_angle) - ul_y * sin(r_angle)
	new_yl = ul_y * cos(r_angle) + ul_x * sin(r_angle)
	;
	;print, 'old UR (x,y) = ',ur_x, ur_y
	;print, 'new UR (x,y) = ',new_xr, new_yr
	;
	;print, 'old UL (x,y) = ',ul_x, ul_y
	;print, 'new UL (x,y) = ',new_xl, new_yl
	;
	exp_y = abs(new_yr) / abs(ur_y)
	;print, "Y expansion = ",exp_y
	;
	exp_x = abs(new_xl) / abs(ul_x)
	;print, "X expansion = ",exp_x
	;
	expansion_factor = exp_x > exp_y
	;print, "larger expansion = ",expansion
	;
end
