pro S0_Draw_Circle, image_ptr, coords, color_index
;
;	for the indicated image, goes to coords.x0, .y0
;	and draws a circle of the color_index for radius
;	.r
;
;	will not draw outside image
;
;	DPC	20110106
;
image_size = SIZE( (*image_ptr) )
nx = image_size[1]
ny = image_size[2]
;
;	test that the center is on the image
;
new_coords = coords
;
if(new_coords.x0 lt 0 or new_coords.x0 gt (nx-1)) then goto, the_end
if(new_coords.y0 lt 0 or new_coords.y0 gt (ny-1)) then goto, the_end
;
;	for a box around the current coordinates
;
rbox = round( new_coords.r ) + 2
;
x_0 = round(((new_coords.x0 - rbox) > 0) < (nx-1))
x_1 = round(((new_coords.x0 + rbox) > 0) < (nx-1))
y_0 = round(((new_coords.y0 - rbox) > 0) < (ny-1))
y_1 = round(((new_coords.y0 + rbox) > 0) < (ny-1))
;
for ix = x_0, x_1 do begin
	for iy = y_0, y_1 do begin
		;
		;	distance from this pixel to the center?
		;
		dist = sqrt( (float(ix) - new_coords.x0)^2 + (float(iy) - new_coords.y0)^2)
		;
		ddist = abs(dist - new_coords.r)
		;
		if(ddist lt 0.4999) then (*image_ptr)[ix,iy] = color_index
	endfor
endfor
;
the_end:
;
end