function d_MOMENT, vec
;
;   shortened version of MOMENT, designed for fast use by
;   median_filtered_mean routine
;
;   returns mean and variance
;
;   DPC   20051023  original code
;
this_mean = dblarr(2)
nv = size(vec)
nv = long(nv[1])
fnv = double(nv)
ind = WHERE(FINITE(vec))
this_vec = double(vec(ind))
;
;   compute sums
;
this_mean[0] = TOTAL(this_vec,/DOUBLE)
this_mean[1] = TOTAL(this_vec*this_vec,/DOUBLE)
;
this_mean[0] = this_mean[0] / fnv
;
this_mean[1] = (this_mean[1]/fnv) - this_mean[0]*this_mean[0]
;
if(this_mean[1] lt 0.0) then this_mean[1] = this_mean[0] * this_mean[0]
;
return, this_mean
end