pro S0_Expansion_from_Rotation
;
;	compute the image size to expand by to
;	keep the rotated image within the total
;	image boundary
;
nx = 3900
ny = 2400
;
image = fltarr(nx, ny)
image += 1.0
;
angle = 27.3; deg
r_angle = angle * !DPI / 180.0
;
;-------------------------------------------------
;
;	ur corner, from center
;
ur_x = nx / 2.0
ur_y = ny / 2.0
;
ul_x = -ur_x
ul_y = ur_y
;
;	rotate CCW
;
new_xr = ur_x * cos(r_angle) - ur_y * sin(r_angle)
new_yr = ur_y * cos(r_angle) + ur_x * sin(r_angle)
;
new_xl = ul_x * cos(r_angle) - ul_y * sin(r_angle)
new_yl = ul_y * cos(r_angle) + ul_x * sin(r_angle)
;
print, 'old UR (x,y) = ',ur_x, ur_y
print, 'new UR (x,y) = ',new_xr, new_yr
;
print, 'old UL (x,y) = ',ul_x, ul_y
print, 'new UL (x,y) = ',new_xl, new_yl
;
exp_y = abs(new_yr) / abs(ur_y)
print, "Y expansion = ",exp_y
;
exp_x = abs(new_xl) / abs(ul_x)
print, "X expansion = ",exp_x
;
expansion = exp_x > exp_y
print, "larger expansion = ",expansion
;
end