pro s0_write_tiff_image
;
;
file_in = dialog_pickfile()
image = readfits(file_in)
test_image = image
;
ind_good = WHERE(image gt -1.0e4, ngood)
if(ngood gt 0) then test_image = test_image[ind_good]
;
zz = median_filtered_mean(test_image)
;
loadct, 0, RGB_TABLE = rgb_table	; fetch the lookup table
special = 	[  0,255,255,	255,255, 50,  0,148,233, $
	  		   0,255,  0,	165,200,185,  0,  0,233, $
	  		   255,0,  0,  	0,  0, 0,	255,255,255]
;
;	invert table to get B on W
;
offset = 11
ncolors = !D.TABLE_SIZE
new_rgb_table = rgb_table * 0
for ic = 0, (ncolors-offset) do begin
	new_rgb_table[ic,*] = rgb_table[ncolors-offset-ic,*]
endfor
;
rgb_table = new_rgb_table
for i=1,9 do begin
	rgb_table[i,0] = special[(i-1)*3]
	rgb_table[i,1] = special[(i-1)*3 + 1]
	rgb_table[i,2] = special[(i-1)*3 + 2]
endfor
;
;	scale image from -2 sigma below mean to 1/10 max
;
low_cut = zz[0] - zz[1]
range = 0.075 * MAX(image)
;
;	first test - linear scaling
;
;image8 = (image - low_cut) / range
;
;	next, sqrt scaling
;
image8 = sqrt(image - low_cut) / sqrt(range)
;
;	and then vertical flip
;
image_size = SIZE(image8)
nx = image_size[1]
ny = image_size[2]
;
new8 = image8
;
for iy = 0, ny-1 do begin
	new8[*,iy] = image8[*,ny-1-iy]
endfor
;
;	scale to 11-255
;
offset = 11
b_range = 255 - offset
;
image8 = byte( (((new8 * b_range) + offset) > offset) < 255)
;
;	draw a test line as red
;
image8[100:140,500:510] = 1
image8[100:140,450:460] = 2
image8[100:140,400:410] = 3
image8[100:140,350:360] = 4
image8[100:140,300:310] = 5
image8[100:140,250:260] = 6
image8[100:140,200:210] = 7
image8[100:140,150:160] = 8
image8[100:140,100:110] = 9
;
;	expand 5x5
;
;image8 = CONGRID(image8, 2*nx, 2*ny, /INTERP)
;
;	write as tiff file
;
write_tiff, dialog_pickfile(Title='Tiff image'), image8, RED=REFORM(rgb_table[*,0]), $
			GREEN=REFORM(rgb_table[*,1]), BLUE=REFORM(rgb_table[*,2])
;
end